package com.style24.batch.biz.job.marketing;

import java.util.Collection;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.gagaframework.web.parameter.GagaMap;
import com.style24.batch.biz.job.TsbAbstractJob;
import com.style24.batch.biz.service.TsbGiftcardService;
import com.style24.core.biz.service.TscKakaotalkService;
import com.style24.persistence.domain.GiftCard;

import lombok.extern.slf4j.Slf4j;

@Component
@Slf4j
public class TsbExpectGiftcardJob  extends TsbAbstractJob<Collection<GiftCard>, GagaMap, GagaMap>{
	
	@Autowired
	TsbGiftcardService giftcardService;
	
	@Autowired
	TscKakaotalkService kakaoService;
	
	private int succCnt = 0;
	private int failCnt = 0;

	
	@Override
	public Collection<GiftCard> read() throws Exception {
		GiftCard giftcard = new GiftCard(); 
		return giftcardService.getSendGiftcardExpectList(giftcard);
	}

	@Override
	public GagaMap process(Collection<GiftCard> readItem) throws Exception {
		for (GiftCard giftcard : readItem) {
			try {
				kakaoService.sendGiftcardExpectNotify(giftcard, giftcard.getCustNo());
				succCnt++;
			} catch (Exception e) {
				failCnt++;
				log.error(e.getMessage());
			}
		}
		return null;
	}

	@Override
	public GagaMap write(GagaMap convertedItem) throws Exception {
		return null;
	}

	@Override
	public void notify(GagaMap resultItem) throws Exception {
		super.printResult(succCnt, failCnt);
	}

}
